You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

bashrc 20 KiB

12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
11 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
11 years ago
11 years ago
11 years ago
11 years ago
12 years ago
123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889
  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. __match(){
  39. # __match str1 str2
  40. # return 0 if str2 is found in str1
  41. expr "$1" : ".*$2.*" >/dev/null
  42. }
  43. if ! __match "$PATH" "$HOME/.local/bin"
  44. then
  45. PATH="${PATH}:${HOME}/.local/bin:$HOME/.local/lib/gems/bin"
  46. fi
  47. if ismsys && ! __match "$PATH" /c/mingw/bin
  48. then
  49. PATH="$PATH:/c/mingw/bin:/c/mingw/msys/1.0/bin"
  50. fi
  51. # # it is not so good
  52. # # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  53. # # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  54. # without this ENV i cannot run tmux. another way is to use --disable-shared
  55. # when building tmux
  56. if ! __match "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  57. then
  58. export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  59. fi
  60. ##################################
  61. export LANG=ja_JP.UTF-8
  62. export LC_MESSAGES=C
  63. export TERMCAP="${TERMCAP}:vb="
  64. ismsys && export HOSTNAME
  65. export ENV=~/.shrc
  66. if false iswindows
  67. then
  68. export PAGER='tr -d \\r | less'
  69. else
  70. export PAGER="less"
  71. fi
  72. export LESS="-iRMX"
  73. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  74. if test -n "$_src_hilite_lp_path"
  75. then
  76. export LESSOPEN="| $_src_hilite_lp_path %s"
  77. fi
  78. if null type vim
  79. then
  80. export EDITOR=vim
  81. else
  82. export EDITOR=vi
  83. fi
  84. # export CDPATH=".:~"
  85. export VISUAL="$EDITOR"
  86. export GIT_PAGER="less -F"
  87. export GIT_EDITOR="$EDITOR"
  88. export GIT_MERGE_AUTOEDIT=no
  89. if test -n "$TMUX" && \
  90. echo $TERM | grep screen >/dev/null 2>&1 && \
  91. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  92. then
  93. TERM=screen-256color
  94. fi
  95. if test -z "$TMP"
  96. then
  97. if test -n "$TMPDIR"
  98. then
  99. export TMP=$TMPDIR
  100. elif test -n "$TEMP"
  101. then
  102. export TMP="$TEMP"
  103. else
  104. export TMP=/tmp
  105. fi
  106. fi
  107. __match "$TMP" "${USER}-tmp" >/dev/null || export TMP="${TMP}/${USER}-tmp"
  108. export TEMP="$TMP"
  109. mkdir -p "$TMP"
  110. ! iswindows && null type stty && {
  111. stty stop undef # unbind C-s to stop displaying output
  112. # stty erase '^h'
  113. }
  114. if iswindows; then
  115. export USER=$USERNAME
  116. fi
  117. _tmux_prefs(){
  118. null type tmux || return 1
  119. tmux set -g mode-keys vi
  120. }
  121. if test -d ~/dbx
  122. then
  123. export CHIT_PATH="$HOME/dbx/.chit"
  124. fi
  125. #######################
  126. iswindows && alias tty="echo cmd.exe"
  127. type fortune >/dev/null 2>&1 && {
  128. fortune
  129. echo
  130. fortune -o
  131. echo
  132. }
  133. uname -a
  134. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  135. running $BASH $BASH_VERSION
  136. if test -n "$TMUX"
  137. then
  138. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  139. 2>/dev/null
  140. echo
  141. fi
  142. ###################################
  143. # some aliases and functions
  144. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  145. _coloroption=" --color=auto"
  146. ( ! with_coreutils && isdarwin ) || iswindows || \
  147. _timeoption=" --time-style=long-iso"
  148. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  149. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  150. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  151. _timeformat_num="%Y%m%d%H%M%S"
  152. alias datenum="date +$_timeformat_num"
  153. alias ls="ls -hCF${_coloroption}${_timeoption}"
  154. if ! with_coreutils
  155. then
  156. export LSCOLORS=gxfxcxdxbxegedabagacad
  157. alias ls="ls -G"
  158. fi
  159. # export GREP_OPTIONS=""
  160. alias gr="grep -n --color=always"
  161. iswindows && alias grep="grep -n"
  162. # alias ll="ls -l"
  163. # alias la="ls -A"
  164. # alias lla="ls -Al"
  165. alias less="less -F"
  166. null type emacs && alias em="emacs -nw"
  167. null type vim && alias vi=vim
  168. alias pstree="LANG=C pstree"
  169. alias cp="cp -v"
  170. alias mv="mv -v"
  171. alias rm="rm -v"
  172. alias psaux="ps auxww"
  173. alias q=exit
  174. null type e3em && alias e3=e3em
  175. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  176. alias po=popd
  177. alias pu=pushd
  178. null type sudo && alias sudo="sudo " # use aliases through sudo
  179. null type sudoedit && alias sudoe="sudoedit"
  180. null type halt && alias halt="sudo halt"
  181. null type reboot && alias reboot="sudo reboot"
  182. null type dbus-send && {
  183. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  184. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  185. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  186. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  187. }
  188. alias rand="echo \$RANDOM"
  189. null type file-roller && alias xunp="file-roller -h"
  190. null type paco && alias pc="sudo \paco -D"
  191. alias pycalc="python -i -c 'from math import *' "
  192. null type python3 && alias py3=python3
  193. null type python2 && alias py2=python2
  194. alias _reloadrc="exec \"$SHELL\""
  195. # alias mytime="date +%Y%m%d-%H%M%S"
  196. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  197. # type trash >/dev/null 2>&1 && alias rm=trash
  198. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  199. null type xmms2 && alias xm="xmms2"
  200. #export PLAYER="mpg123 -C -v --title"
  201. null type screen && alias screen="screen -e^z^z"
  202. #alias zcd="cd \`zenity --file-selection --directory\`"
  203. null type gtags && alias gtags="gtags --verbose"
  204. null type htags && alias htags="htags --xhtml --symbol --line-number \
  205. --frame --alphabet --verbose"
  206. null type aunpack && alias au=aunpack
  207. null type lv && alias lv="lv|less"
  208. null type rsync && alias rs="rsync --progress --itemize-changes --compress"
  209. isdarwin && alias updatedb="LC_ALL=C updatedb"
  210. # do not use locate installed by macports
  211. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  212. # pad
  213. alias pad=notepad
  214. null type gedit && alias pad=gedit
  215. null type leafpad && alias pad=leafpad
  216. isdarwin && alias pad="open -e"
  217. null type wicd-curses && alias wic=wicd-curses
  218. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  219. #alias wicn="wicd-cli -y -c -n"
  220. wicn(){
  221. if test $# -eq 0
  222. then
  223. local num
  224. wicd-cli -y -l | head
  225. echo -n "input num: "
  226. read num
  227. test -n "$num" && wicd-cli -y -c -n $num
  228. else
  229. wicd-cli -y -c -n $1
  230. fi
  231. }
  232. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  233. /usr/share/vim/vim73/macros/less.sh \
  234. /usr/share/vim/vim72/macros/less.sh
  235. do
  236. test -f $f && alias vl=$f && break
  237. done
  238. null type yaourt && alias yt=yaourt
  239. null type cower && alias cower="cower --color=auto"
  240. null type pacmatic && {
  241. alias pacman="pacmatic"
  242. export PACMAN="pacmatic"
  243. }
  244. _pacman_update_mirrorlist_with_reflector(){
  245. ml=/etc/pacman.d/mirrorlist
  246. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  247. if test -z "$cmd"
  248. then
  249. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  250. fi
  251. echo "Running $cmd ..." 1>&2
  252. sudo $cmd
  253. }
  254. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  255. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  256. null type apt-get && {
  257. alias aupgrade="sudo apt-get autoremove --yes && \
  258. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  259. alias aptin="apt-get install"
  260. alias aptsearch="apt-cache search"
  261. alias aptshow="apt-cache show"
  262. }
  263. null type port && {
  264. alias port="port -v"
  265. alias pupgrade="sudo port -v selfupdate && \
  266. { sudo port -v upgrade outdated; }"
  267. }
  268. if iscygwin; then
  269. null type windate || \
  270. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  271. # alias cygsu="cygstart /cygwinsetup.exe"
  272. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  273. fi
  274. g(){
  275. if test $# -eq 0 && null type git-info
  276. then
  277. git info
  278. else
  279. git "$@"
  280. fi
  281. }
  282. if null type _git && inbash
  283. then
  284. # enable programmable completion for g
  285. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  286. || complete -o default -o nospace -F _git g
  287. fi
  288. git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  289. null type gitmemo && alias m=gitmemo
  290. null type gitmemo && alias m=gitmemo
  291. alias setup.py="sudo python3 setup.py install --record files.txt"
  292. ssh(){
  293. __my_set_screen_title ssh
  294. command ssh "$@"
  295. }
  296. clk(){
  297. local tformat="%Y/%m/%d %H:%M:%S %z"
  298. cal
  299. REPLY=
  300. printf "\\r`date "+${tformat}"`"
  301. read -t 1
  302. while test $? -ne 0
  303. do
  304. printf "\\r`date "+${tformat}"`"
  305. read -t 1
  306. done
  307. }
  308. s(){
  309. # if test $# -eq 0
  310. # then
  311. # echo "No search word given." 1>&2
  312. # return 1
  313. # fi
  314. if git rev-parse --git-dir >/dev/null 2>&1
  315. then
  316. echo ">> Using git-grep" 1>&2
  317. git grep -n "$@"
  318. elif which ag >/dev/null 2>&1
  319. then
  320. echo ">> Using ag" 1>&2
  321. ag --pager="$PAGER" "$@"
  322. elif which ack >/dev/null 2>&1
  323. then
  324. echo ">> Using ack" 1>&2
  325. ack --pager="$PAGER" "$@"
  326. else
  327. echo ">> Using grep" 1>&2
  328. if test $# -eq 0
  329. then
  330. echo "No search word given." 1>&2
  331. return 1
  332. fi
  333. grep -nH --color=always --exclude='.svn/*' --exclude='.git/*' "$@" -r . \
  334. | $PAGER
  335. # echo "No search command found. Use grep." 2>&1
  336. # return 127
  337. fi
  338. }
  339. man(){
  340. env \
  341. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  342. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  343. LESS_TERMCAP_me=$(printf "\e[0m") \
  344. LESS_TERMCAP_se=$(printf "\e[0m") \
  345. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  346. LESS_TERMCAP_ue=$(printf "\e[0m") \
  347. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  348. man "$@"
  349. }
  350. scr(){
  351. test -n "$1" && pf="${1}-"
  352. local _tformat="%Y%m%d-%H%M%S%z"
  353. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  354. SCRIPT=${_file} script ${_file} "$@"
  355. }
  356. netwait(){
  357. while ! ping -c 1 -t 1 example.com
  358. do
  359. true
  360. done
  361. echo network works.
  362. }
  363. cd(){
  364. if test $# -eq 0
  365. then
  366. pushd ~/ >/dev/null
  367. elif test "$1" = -
  368. then
  369. local pwd="$PWD"
  370. command cd "$OLDPWD"
  371. pushd -n "$pwd" >/dev/null # stack last dir
  372. elif ! test -d "$1"
  373. then
  374. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  375. return 1
  376. else
  377. pushd "$1" >/dev/null
  378. fi
  379. __dirs_rm_dup "$PWD"
  380. echo "$PWD"
  381. }
  382. __dirs_rm_dup(){
  383. for d in "$@"
  384. do
  385. local next="$(__realpath --strip "$d")"
  386. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  387. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  388. do
  389. popd +$l -n >/dev/null
  390. done
  391. done
  392. }
  393. __realpath(){
  394. if type realpath >/dev/null 2>&1
  395. then
  396. command realpath "$@"
  397. else
  398. while ! test -d $1
  399. do
  400. shift
  401. done
  402. local d="$OLDPWD"
  403. command cd "$1"
  404. echo "$PWD"
  405. command cd "$d"
  406. fi
  407. }
  408. dh(){
  409. if test $# -eq 0
  410. then
  411. dirs -v -l
  412. else
  413. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  414. cd "$dir"
  415. fi
  416. }
  417. input(){
  418. local foo
  419. stty -echo
  420. read foo
  421. stty echo
  422. echo $foo
  423. }
  424. # tmux(){
  425. # if test $# -eq 0
  426. # then
  427. # (cd ~; command tmux start;)
  428. # if command tmux has -t main
  429. # then
  430. # command tmux attach -t main
  431. # else
  432. # (cd ~; command tmux new -s main;)
  433. # fi
  434. # else
  435. # command tmux "$@"
  436. # fi
  437. # }
  438. tx(){
  439. if test $# -eq 0
  440. then
  441. tmux ls
  442. echo "tx <session> to attach."
  443. elif tmux has -t "$1"
  444. then
  445. tmux attach -t "$1"
  446. else
  447. tmux new -s "$1"
  448. fi
  449. }
  450. mcrypt-stream(){
  451. test $# -eq 2 || return 1
  452. case $1 in
  453. en)
  454. mcrypt --key $2 | base64 ;;
  455. de)
  456. base64 -d | mcrypt -d --key $2 ;;
  457. esac
  458. }
  459. gpg-stream(){
  460. test $# -eq 2 || return 1
  461. case $1 in
  462. en)
  463. gpg --passphrase $2 -c --batch |base64 ;;
  464. de)
  465. base64 -d|gpg --passphrase $2 -d --batch ;;
  466. esac
  467. }
  468. dgpg(){
  469. if test "$1" = help || test -z "$2"
  470. then
  471. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  472. return
  473. fi
  474. local srcs="$2"
  475. local dsts="$3"
  476. test -z "$dsts" && dsts="${srcs}.out"
  477. local pw
  478. echo -n "dgpg pw: "
  479. read -s pw
  480. echo ""
  481. test -z "$pw" && return 1
  482. for f in *${srcs}
  483. do
  484. local d="$(basename "$f" "${srcs}")${dsts}"
  485. echo -n "Processing $f to $d..."
  486. if test -d "$f"
  487. then
  488. echo "`printf 'failed (%s is directory)' $f`"
  489. elif test -f "$d"
  490. then
  491. echo "`printf 'failed (%s is already exists)' $d`"
  492. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  493. then
  494. echo "done"
  495. else
  496. echo "failed"
  497. test -f "$d" && rm "$d"
  498. fi
  499. done
  500. }
  501. alias enst="gpg-stream en"
  502. alias dest="gpg-stream de"
  503. showinfo(){
  504. echo "Japanese letters are 表示可能"
  505. __try_exec diskinfo
  506. ! isdarwin && test -n "${DISPLAY}" && {
  507. __try_exec xrandr | \grep --color=never ^Screen
  508. }
  509. iswindows || __try_exec finger $USER
  510. LANG=C __try_exec id
  511. __try_exec xset q
  512. }
  513. x(){
  514. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  515. #mkdir -p ~/.my/log
  516. # nohup startx >~/.my/log/xorg.log 2>&1 &
  517. # exit
  518. exec startx
  519. else
  520. echo "X cant be started! Another X is already running?" 1>&2
  521. fi
  522. }
  523. bak(){
  524. for file in "$@"
  525. do
  526. cp -v ${file} ${file}.bak
  527. done
  528. }
  529. di(){
  530. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  531. then
  532. local diffcmd=colordiff
  533. else
  534. local diffcmd=diff
  535. fi
  536. ${diffcmd} -u "$@" | ${PAGER}
  537. }
  538. tb(){
  539. local tb="$HOME/.my/tb"
  540. mkdir -p "$tb"
  541. for file in "$@"
  542. do
  543. mv -t "$tb" "$file"
  544. done
  545. }
  546. mkcd(){
  547. if test -z "$1"
  548. then
  549. echo "mkcd: usage: mkcd <dir>"
  550. return 1
  551. elif test -d "$1"
  552. then
  553. echo "Dir \"$1\" already exists."
  554. else
  555. mkdir -p "$1"
  556. echo "Dir \"$1\" created."
  557. fi
  558. cd "$1"
  559. }
  560. mkcdd(){
  561. # make and change date directory
  562. _d=`date +%Y%m%d-%H%M%S`
  563. mkcd "$_d"
  564. }
  565. if test -n "$TMUX" && null type reattach-to-user-namespace
  566. then
  567. alias pbpaste="reattach-to-user-namespace pbpaste"
  568. alias pbcopy="reattach-to-user-namespace pbcopy"
  569. fi
  570. catclip(){
  571. if iswindows
  572. then
  573. cat /dev/clipboard | tr -d \\r
  574. elif isdarwin
  575. then
  576. pbpaste
  577. else
  578. xclip -o -selection "clipboard"
  579. fi
  580. }
  581. setclip(){
  582. if test $# -eq 0
  583. then
  584. exec 3<&0
  585. else
  586. exec 3<<__EOF__
  587. `cat "$@"`
  588. __EOF__
  589. fi
  590. if iswindows
  591. then
  592. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  593. elif isdarwin
  594. then
  595. pbcopy 0<&3
  596. else
  597. 0<&3 xclip -i -f -selection "primary" | \
  598. xclip -i -f -selection "clipboard"
  599. fi
  600. exec 3<&-
  601. }
  602. open_file(){
  603. if iswindows
  604. then
  605. cmd.exe //c start "" "$@"
  606. elif isdarwin
  607. then
  608. touch "$@"
  609. open "$@"
  610. elif islinux
  611. then
  612. touch "$@"
  613. if null type pcmanfm; then
  614. LC_MESSAGES= pcmanfm "$@"
  615. else
  616. LC_MESSAGES= xdg-open "$@" &
  617. fi
  618. else
  619. cat "$@"
  620. fi
  621. }
  622. o(){
  623. if test $# -eq 0
  624. then
  625. open_file .
  626. else
  627. for f in "$@"
  628. do
  629. open_file "$(realpath "$f")"
  630. done
  631. fi
  632. }
  633. convmv-sjis2utf8-test(){
  634. convmv -r -f sjis -t utf8 *
  635. }
  636. convmv-sjis2utf8-notest(){
  637. convmv -r -f sjis -t utf8 * --notest
  638. }
  639. winln(){
  640. # for windose make link (actually junction)
  641. if test $# -eq 0
  642. then
  643. {
  644. echo "usage: winln TARGET LINK_NAME"
  645. echo "Create a link to TARGET with the name LINK_NAME \
  646. (that is, TARGET must already exist)."
  647. echo "About other features run 'junction'."
  648. } 1>&2
  649. return 1
  650. else
  651. junction "$2" "$1"
  652. fi
  653. }
  654. __my_moc_state(){
  655. type mocp >/dev/null 2>&1 || return
  656. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  657. printf "$1" "`mocp -Q %title 2>/dev/null`"
  658. }
  659. __my_parse_svn_branch() {
  660. local LANG=C
  661. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  662. local svn_repository_root=$(svn info 2>/dev/null | \
  663. sed -ne 's#^Repository Root: ##p')
  664. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  665. awk '{print $1}'
  666. }
  667. __my_svn_ps1(){
  668. if svn status >/dev/null 2>&1
  669. then
  670. local svn_branch=$(__my_parse_svn_branch)
  671. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  672. fi
  673. }
  674. __my_battery_status(){
  675. local dir=/sys/class/power_supply/BAT0
  676. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  677. test -r $dir/charge_now
  678. then
  679. local st=$(cat $dir/status)
  680. local full=$(cat $dir/charge_full)
  681. local now=$(cat $dir/charge_now)
  682. local rate=$(expr $now \* 100 / $full)
  683. printf "$1" "${st}:${rate}%"
  684. fi
  685. }
  686. alias bat='__my_battery_status %s\\n'
  687. ip-address(){
  688. type ip >/dev/null 2>&1 || return 1
  689. local ip=$(LANG=C ip addr show scope global | \
  690. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  691. test -n "$ip" && printf $1 $ip
  692. }
  693. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  694. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  695. __my_ps1_scale(){
  696. local last=$?
  697. printf "${LINES}x${COLUMNS}"
  698. return $last
  699. }
  700. __my_ps1_tmux(){
  701. local last=$?
  702. null type tmux || return $last
  703. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  704. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  705. return $last
  706. }
  707. __my_ps1_moc(){
  708. local last=$?
  709. __my_moc_state "[MOC:%s]"
  710. return $last
  711. }
  712. for f in /usr/share/git/git-prompt.sh \
  713. /opt/local/share/git-core/git-prompt.sh \
  714. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  715. do
  716. test -r $f && . $f && break
  717. done
  718. GIT_PS1_SHOWDIRTYSTATE=t
  719. GIT_PS1_SHOWUPSTREAM=t
  720. __my_ps1_git(){
  721. local last=$?
  722. null type __git_ps1 || return $last
  723. null __gitdir || return $last
  724. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  725. return $last
  726. }
  727. __my_ps1_ipaddr(){
  728. local last=$?
  729. ! iswindows && ip-address [Addr:%s]
  730. return $last
  731. }
  732. __my_ps1_bttry(){
  733. local last=$?
  734. local bst="${TMP}/batterystatus"
  735. if test -z "$DISPLAY" && ! iswindows
  736. then
  737. test -f $bst && local bstr="$(cat $bst)"
  738. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  739. echo "[Battery:$bstr]"
  740. __my_battery_status %s >$bst &
  741. fi
  742. return $last
  743. }
  744. __my_ps1_dirs(){
  745. dirs | wc -l
  746. }
  747. __my_ps1_jobs(){
  748. jobs | wc -l
  749. }
  750. if test "$TERM" != dumb
  751. then
  752. __my_c1="\[\e[0;33m\]" # color for PWD
  753. __my_c2="\[\e[0;36m\]" # color for user
  754. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  755. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  756. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  757. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  758. else __my_c4="\[\e[1;32m\]" # color for ::
  759. fi
  760. __my_c5="\[\e[30;47m\]" # color for SCR
  761. __my_cdef="\[\e[0m\]"
  762. fi
  763. export _LAST_STATUS=$?
  764. __my_export_last_status(){
  765. export _LAST_STATUS=$?
  766. echo $_LAST_STATUS
  767. return $_LAST_STATUS
  768. }
  769. _ps1_bash="\
  770. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  771. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  772. inbash && PS1=$_ps1_bash
  773. __my_set_screen_title(){
  774. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  775. then
  776. echo -ne "\033k$1\033\\"
  777. fi
  778. }
  779. __my_set_title(){
  780. case $TERM in
  781. (rxvt*|xterm*|aterm|screen*)
  782. title="$(echo $@)"
  783. test -t 1 &&
  784. test -n "$DISPLAY" &&
  785. test -z "$EMACS" &&
  786. echo -n -e "\033]0;${title}\007"
  787. ;;
  788. esac
  789. }
  790. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  791. __my_set_screen_title \$(basename \"\$PWD\")/"